/*******************************************************************************
* Freescale Semiconductor Inc.
* (c) Copyright 2014 Freescale Semiconductor, Inc.
* ALL RIGHTS RESERVED.
********************************************************************************
Services performed by FREESCALE in this matter are performed AS IS and without
any warranty. CUSTOMER retains the final decision relative to the total design
and functionality of the end product. FREESCALE neither guarantees nor will be
held liable by CUSTOMER for the success of this project.
FREESCALE DISCLAIMS ALL WARRANTIES, EXPRESSED, IMPLIED OR STATUTORY INCLUDING,
BUT NOT LIMITED TO, IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR
A PARTICULAR PURPOSE ON ANY HARDWARE, SOFTWARE ORE ADVISE SUPPLIED TO THE PROJECT
BY FREESCALE, AND OR NAY PRODUCT RESULTING FROM FREESCALE SERVICES. IN NO EVENT
SHALL FREESCALE BE LIABLE FOR INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THIS AGREEMENT.
CUSTOMER agrees to hold FREESCALE harmless against any and all claims demands or
actions by anyone on account of any damage, or injury, whether commercial,
contractual, or tortuous, rising directly or indirectly as a result of the advise
or assistance supplied CUSTOMER in connection with product, services or goods
supplied under this Agreement.
********************************************************************************
* File I2C.h
* Owner b35804
* Version 1.0
* Date Apr-25-2014
* Classification General Business Information
* I2C memory map
********************************************************************************
* Detailed Description: I2C 
********************************************************************************
Revision History:
Version		 Date		 Author			 Description of Changes
*******************************************************************************/

#ifndef I2C_H_
#define I2C_H_

#define I2C_DisableAck()       I2C1_C1 |= I2C_C1_TXAK_MASK	// 0000 0000 | 0000 1000
#define I2C_EnableAck()        I2C1_C1 &= ~I2C_C1_TXAK_MASK	// 0000 1000 & 1111 0111
#define I2C_RepeatedStart()    I2C1_C1 |= I2C_C1_RSTA_MASK	// 0000 0000 | 0000 0100
#define I2C_EnterRxMode()      I2C1_C1 &= ~I2C_C1_TX_MASK	// 0000 0000 | 0001 0000
#define I2C_write_byte(data)   I2C1_D = data

#define I2C_Start()            I2C1_C1 |= I2C_C1_TX_MASK;\
                               I2C1_C1 |= I2C_C1_MST_MASK

#define I2C_Stop()             I2C1_C1 &= ~I2C_C1_MST_MASK;\
                               I2C1_C1 &= ~I2C_C1_TX_MASK

#define I2C_Wait()             while((I2C1_S & I2C_S_IICIF_MASK)==0) {} \
                               I2C1_S |= I2C_S_IICIF_MASK;

void I2C_WriteRegister(unsigned char u8SlaveAddress, unsigned char u8RegisterAddress, /*unsigned*/ char u8Data);
unsigned char I2C_ReadRegister(unsigned char u8SlaveAddress, unsigned char u8RegisterAddress);
void I2C_ReadMultiRegisters(unsigned char u8SlaveAddress, unsigned char u8RegisterAddress, unsigned char n, unsigned char *r);
void Pause(int number);

#endif /* I2C_H_ */
